#PBForms CREATED V2.01
#Compile Exe
#Dim All
#Debug Error On
#Debug Display On
#Tools Off
' #Option AnsiApi
#Unique Var On
' %Unicode = 1

' tab ddt version of code formatter
' 11/23/2011 v3 re-arrange GUI again
'               don't have format_cliked yet
' 11/24/2011    got format_clicked in place
'               fixed problem with text_ascoumn
' 11/25/2011    changing string concats to & instead of +
'               changing concat/add/sub if left var is 1st on right to &=/+=/-=
' 11/26/2011    fix for DIM x(1, 4)
'               handle multiple AS type on 1 line
'               indents variables -- still need fix if it can't fit in space *ERR
' 11/27/2011    eliminated *ERR
'               add ENUM to list of auto-indent
'               process THREAD FUNCTION like CALLBACK FUNCTION
'               indent continued lines tabsize
'              * still need to process continued variable declares
' 11/28/2011    put in progressbar
'               initialized mainhWnd
' 11/29/2011    changed from mainhWnd to mainhDlg
' 12/05/2011 v4 using fc.indent to get initial indent
'               comment out fc.RoutineColumn() & fc.RoutineIDX
'               trouble with Peter's INSTR(... "#PBFORMS " )
' 12/07/2011    put #PBFORMS handling in RebuildLine where it belongs
'               ? fix ( _ coming out as (_
' 12/08/2011 v5 testing split variables using RebuildLine array
' 12/09/2011 08:30am mostly working -- except continuation
' 12/10/2011 06:00am starting to handle oldstyle and no AS
'               adding REDIM to variable allowed
'            03:00pm even got variable continuation lines working
'            05:20pm forgot to reset all flags/hold areas for variable continuation
' 12/11/2011 08:00am using original capitalization for variable lines
'               putting max tokens on status line
' 12/13/2011 11:10am fix split with no AS
' 12/15/2011 08:00am putting ztext of DoFormat back to ASCIIZ * %MAX_LINELEN
' 12/19/2011    adding check for Method =
' 12/21/2011    fix spacing & capitalization of equates
'               still work to do on : & REM at end
' 12/22/2011    code after call Line2Word handles changing : & REM to ' plus next entry
'                and adjusts WordCount & deletes w() entries
' 12/23/2011 07:00pm v6 working on aligning TYPE/UNION entries
' 12/24/2011 09:30am put len check when reading .cfg file
'               indent ENUM entries
'               fix deleting file if not there
' 12/26/2011    put version in CFG UDT
'               moved save/default options buttons down
' 12/27/2011    changed source $keyword to #keyword for 21 keywords
' 12/28/2011    synced up conditions on IF lines for continued & splitvariable in DoFormat
' 12/29/2011    add icon to dialog
'               move default options btn to right & save options btn lower
'               upped default font to point 10
'               add 3rd tab for Compiler Version/Options
' 12/30/2011    add Catch & Finally & treat Try/End Try same as Select/End Select
'               include wn10keys.inc & cc06keys.inc in prep for future plans
'               ** some keywords have . in them
' 12/31/2011    simplify the $/# synonym check & put in RebuildLine
'             **Peter disables capequates/equatescolumn if formatequates is unchecked
'                but isn't consistant in usage
'               re-arrange Equate section and stop disabling any controls
'               removed unneeded code
'               commenting SplitVariable
'               got keyword casing working -- ignore variable name in type/union
' 01/01/2012 04:30pm put keyword casing in it's own SUB
'               handles the multi-part keyword with up to 2 .
' 01/02/2012    properly indent a couple routines copied from Peter
' 01/05/2012    took condition off endless Loop -- not needed
' 01/06/2012    rtrim type/union/enum output if no comment
'               redid spacing within ()
'               rtrim variable if no comment in case no AS
' 01/09/2012    change PBVersion to ASCIIZ
' 01/11/2012    fix last chg of 01/06/2012
' 01/14/2012    only create cf.dmp if needed
'               arrange fmtoptions to match screen
'               consider bypassing reformat of MACROs -- optional declaration line -- NOT usage line
' 01/16/2012 v7 split some keywords out into separate case statements ( type / union / enum / sub )
'               keep track of macros with params
'               have to work around formatmacro = 0 and still be able to format macro usage
' 01/17/2012    handled saving/restoring fc if formatmacro = 0
'               handle multiple macros per line
'               only load keywords if different version from last load
' 01/18/2012    indent DATA statements
'              ?handle AsmData & End AsmData -- may want to output without formatting
'               eliminate space between quoted string & following $ or $$
' 01/21/2012    change #if/#elseif/#else/#endif to start in column 1
'                but not change other indent
' 01/28/2012 v8 re-arrange procedures
' 01/29/2012    syncing up more with Tabjr1
' 01/31/2012    add Prefix/End Prefix
' 02/03/2012 v9 splitting formatting off to a SLL
'               move load PBKeyword into DoFormat
'               add CommCtrl.inc for non-DDT progressbar
' 02/04/2012    if command line then input & output file same name
'               fo.backup forced ON
' 02/06/2012    move fo/fc UDT out to an INC file
' 02/08/2012    commenting out #Option AnsiAPI & %Unicode = 1 seems to work
' 02/10/2012    no need to pass fc to DoFormat
'               made hProgress as Global in main program
' 02/13/2012    changed hProgress to hProgressBar cuz of Jose Include v3
' 02/14/2012    syncing up with tabjr1
'
'------------------------------------------------------------------------------
'   ** Includes **
'------------------------------------------------------------------------------
#PBForms BEGIN INCLUDES
#Include Once "WIN32API.INC"
#PBForms END INCLUDES

#Include Once "CommCtrl.inc" ' needed for non-DDT progressbar
'------------------------------------------------------------------------------
Macro IDI_PROGRAM_ICON = 100
#Resource Icon, IDI_PROGRAM_ICON, "myicon.ico"

#Resource Manifest, 1, "TAB.XML"

#Resource VersionInfo

#If %Def(%BETAVERSION)
    #Resource FileFlags %VS_FF_PreRelease
#Else
    #Resource FileFlags 0
#EndIf

#Resource FileVersion 1, 0, 0, 0
#Resource ProductVersion 1, 0, 0, 0

#Resource StringInfo "0409", "04B0"

#Resource Version$ "CompanyName",      "Elliott Inc."
#Resource Version$ "FileDescription",  "PB Reformatter"
#Resource Version$ "FileVersion",      "00.09.0000"
#Resource Version$ "InternalName",     "PB Reformatter"
#Resource Version$ "OriginalFilename", "TAB.EXE"
#Resource Version$ "LegalCopyright",   "Copyright  2012 Elliott Inc."
#Resource Version$ "ProductName",      "PB Reformatter"
#Resource Version$ "ProductVersion",   "00.09.0000"
#Resource Version$ "Comments",         "A work in progress .. Never to be complete."

'------------------------------------------------------------------------------
'   ** Constants **
'------------------------------------------------------------------------------
%DMPIT               = 0
%DMPVAR              = 0
%CFGVersion          = 6

#PBForms BEGIN CONSTANTS
%IdCancel            =    2
%IDSTATIC            =   -1
%IDD_DIALOG1         =  101
%IDC_TAB1            = 1001
%IDC_Btn_Help        = 1002
%IDC_Btn_Format      = 1003
%IDC_Progress        = 1004
%IDC_StatusBar       = 1005

%IDC_BTN_InputFile   = 1101
%IDC_BTN_OutputFile  = 1102
%IDC_TEXT_InputFile  = 1103
%IDC_TEXT_OutputFile = 1104

%IDC_CHK_CreateBak       = 1201
%IDC_CHK_CreateTimeStamp = 1202
%IDC_TEXT_TabSize        = 1205
%IDC_TEXT_REMColumn      = 1206
%IDC_CHK_FormatMacro     = 1207
%IDC_CHK_FormatEquates   = 1211
%IDC_TEXT_EquateColumn   = 1212
%IDC_CHK_UpCaseEquates   = 1213
%IDC_CHK_SplitVariables  = 1214
%IDC_TEXT_AsColumn       = 1215
%IDC_BTN_SaveOption      = 1251
%IDC_BTN_DefaultOption   = 1252

%IDC_OPT_PBWin           = 1301
%IDC_OPT_PBCC            = 1302
%IDC_OPT_Generic         = 1303
%IDC_CB_Version          = 1304
%IDC_OPT_NoChange        = 1305
%IDC_OPT_Mixed           = 1306
%IDC_OPT_Upper           = 1307
%IDC_OPT_Lower           = 1308
#PBForms END CONSTANTS
'------------------------------------------------------------------------------

%MAX_LINELEN = 400

'------------------------------------------------------------------------------
'   ** Declarations **
'------------------------------------------------------------------------------
Declare CallBack Function ShowDIALOG1Proc()
Declare Function CreateTabCtrl(ByVal hDlg As Dword, ByVal lID As Long, ByVal lCount As Long) As Long
Declare Function ShowDIALOG1(ByVal hParent As Dword) As Long
#PBForms DECLARATIONS
'------------------------------------------------------------------------------

#Include "fofcUDT.inc"

Global fo               As FMTOPTIONS ' needs to be GLOBAL cuz of usage
Global hTabDlg()        As Dword
Global mainhDlg         As Dword
Global NoGui            As Long       ' no dialog/window
Global hProgressBar     As Dword

'------------------------------------------------------------------------------

Macro msghandled
Function = %FALSE
Exit Function
End Macro

'------------------------------------------------------------------------------
'   ** Main Application Entry Point **
'------------------------------------------------------------------------------
Function PBMain()

   Trace New "t.trc"
   Trace On

   If %DMPVAR = 1 Then
      If IsFile("var.txt") Then  Kill "var.txt"
   End If

   If IsFile("macro.usg") Then Kill "macro.usg"

   ' Perform extra application initialization
   If IsTrue CodeFormatter_InitApplication(Command$) Then
      Function = %FALSE
      Exit Function
   End If

   ShowDIALOG1 %HWND_Desktop

   Trace Off
   Trace Close

End Function

'------------------------------------------------------------------------------

Function CodeFormatter_InitApplication( cmdLine As String ) As Long
   Local filenum As Long
   Local aText   As String
   Local iLen    As Long

   filenum = FreeFile
   iLen = -1
   If IsFile("Code Formatter.cfg") Then
      Open "Code Formatter.cfg" For Binary As #filenum
      iLen = Lof(#filenum)
   Else
      iLen = -1
   End If
   If iLen <> SizeOf(fo) Then
      If iLen <> -1 Then
         Close #filenum
         Kill "Code Formatter.cfg"
      End If
      SetDefaultOptions
   Else
      Get #filenum,,fo
      If fo.version <> %CFGVersion Then
         SetDefaultOptions
      End If
   End If
   Close #filenum

   If fo.ascolumn = 0 Then fo.ascolumn = 40

   aText = cmdLine
   'check the command line for a filespec
   If Len(aText) Then
      If IsFile(aText) Then
         fo.fspecin = aText               ' assumes valid source file
         fo.fspecout = aText              ' same for output 02/04/2012
         fo.backup = 1                    ' 02/04/2012 force on
      Else
         MessageBox 0, "File not found" + $Cr + aText, "", %MB_IconInformation
         Function = %TRUE
         Exit Function
      End If
   Else
      Function = %FALSE
      Exit Function
   End If

   NoGui = 1 ' *****

   DoFormat fo

   Function = %TRUE
End Function

'------------------------------------------------------------------------------
'   ** Dialogs **
'------------------------------------------------------------------------------
Function ShowDIALOG1(ByVal hParent As Dword) As Long
   Local lRslt As Long

#PBForms BEGIN DIALOG %IDD_DIALOG1->->
   Local hDlg  As Dword

   Dialog Default Font "MS Sans Serif", 10, 0, 0
   Dialog New Pixels, hParent, "TAB via PBForms v9", 223, 170, 520, 445, %WS_Caption Or _
      %WS_MinimizeBox Or %WS_SysMenu Or %WS_Visible Or %DS_3DLook Or %DS_NoFailCreate Or _
      %DS_SetFont, %WS_Ex_Left Or %WS_Ex_LtrReading Or %WS_Ex_RightScrollbar Or _
      %WS_Ex_ControlParent, To hDlg
   Control Add Tab,        hDlg, %IDC_TAB1,       "Tab1",     11,  18, 489, 303
   Control Add Button,     hDlg, %IDC_Btn_Help,   "&Help",    15, 335, 116,  41
   Control Add Button,     hDlg, %IDC_Btn_Format, "&Format", 195, 335, 116,  41
   Control Add Button,     hDlg, %IdCancel,       "E&xit",   380, 335, 116,  41
   Control Add Progressbar,hDlg, %IDC_Progress,   "",         10, 395, 500,  20, %WS_Child Or %WS_Visible
   'control set color hDlg, %IDC_Progress, %RED, %BLUE
   Control Add Statusbar,  hDlg, %IDC_StatusBar,  "",          0, 425, 514,  20
#PBForms END DIALOG
   mainhDlg = hDlg
   Control Hide mainhDlg, %IDC_Progress

   CreateTabCtrl  hDlg, %IDC_TAB1, 3

   Dialog Set Icon hDlg, "#" & Format$(IDI_PROGRAM_ICON)

   Dialog Show Modal hDlg, Call ShowDIALOG1Proc To lRslt

#PBForms BEGIN CLEANUP %IDD_DIALOG1
#PBForms END CLEANUP

   Function = lRslt
End Function

'------------------------------------------------------------------------------
'   ** CallBacks **
'------------------------------------------------------------------------------
CallBack Function ShowDIALOG1Proc()

   Select Case As Long Cb.Msg
      Case %WM_InitDialog
         ' Initialization handler

      Case %WM_NCActivate
         Static hWndSaveFocus As Dword
         If IsFalse Cb.WParam Then
            ' Save control focus
            hWndSaveFocus = GetFocus()
         ElseIf hWndSaveFocus Then
            ' Restore control focus
            SetFocus(hWndSaveFocus)
            hWndSaveFocus = 0
         End If

      Case %WM_Command
         ' Process control notifications
         Select Case As Long Cb.Ctl
            Case %IDC_Btn_Help
               If Cb.CtlMsg = %BN_Clicked Then
                  MsgBox "help"
                  msghandled
               End If

            Case %IDC_Btn_Format
               If Cb.CtlMsg = %BN_Clicked Then
                  Control Disable mainhDlg, %IDC_BTN_FORMAT
                  Btn_Format_Clicked
                  Control Enable mainhDlg, %IDC_BTN_FORMAT
                  Control Set Focus mainhDlg, %IDC_BTN_FORMAT
                  msghandled
               End If

            Case %IdCancel
               If Cb.CtlMsg = %BN_Clicked Then
                  Dialog End Cb.Hndl, 0
               End If

            Case %IDC_StatusBar

            Case %IDC_TAB1

         End Select
   End Select
End Function

'------------------------------------------------------------------------------

Function Btn_Format_Clicked As Long

   GetOVars    ' Get Contol vars 11/20/2011

   DoFormat fo

End Function

'------------------------------------------------------------------------------
'   ** Real Code **
'------------------------------------------------------------------------------
Function CreateTabCtrl(ByVal hDlg As Dword, ByVal lID As Long, ByVal lCount As Long) As Long
   Local i        As Long
   Local sTxt     As String

   Dim hTabDlg(1 To lCount) As Global Dword

   For i = 1 To lCount
      sTxt = Read$(i)
      Tab Insert Page hDlg, lID, i, 0, sTxt, Call TabProc To hTabDlg(i)
   Next
   Data File, Options, Compiler

   ' PAGE 1
   Control Add Label, hTabDlg(1), %IDSTATIC, "Input File",  15, 25, 66, 16, _
      %WS_Child Or %WS_Visible Or %WS_Group Or %SS_Left
   Control Add Button, hTabDlg(1), %IDC_BTN_InputFile, "...", 445, 25, 26, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %BS_PushButton Or %BS_Center Or %BS_VCenter
   Control Add TextBox, hTabDlg(1), %IDC_TEXT_InputFile, "",  95, 25, 341, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %ES_Left Or %ES_AutoHScroll
   Control Set Text hTabDlg(1), %IDC_TEXT_InputFile, fo.fspecin

   Control Add Label, hTabDlg(1), %IDSTATIC, "Output File", 15, 60, 66, 16, _
      %WS_Child Or %WS_Visible Or %WS_Group Or %SS_Left
   Control Add Button, hTabDlg(1), %IDC_BTN_OutputFile, "...", 445, 60, 26, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %BS_PushButton Or %BS_Center Or %BS_VCenter
   Control Add TextBox, hTabDlg(1), %IDC_TEXT_OutputFile, "", 95, 60, 341, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %ES_Left Or %ES_AutoHScroll
   Control Set Text hTabDlg(1), %IDC_TEXT_OutputFile, fo.fspecout

   ' PAGE 2
   Control Add CheckBox, hTabDlg(2), %IDC_CHK_CreateBak, "Create Bak", 25, 25, 151, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_AutoCheckbox Or %BS_Left Or %BS_VCenter Or %BS_RightButton

   Control Add CheckBox, hTabDlg(2), %IDC_CHK_CreateTimeStamp, "Create Time Stamp", _
      25, 55, 151, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_AutoCheckbox Or %BS_Left Or %BS_VCenter Or %BS_RightButton

   Control Add Label, hTabDlg(2), %IDSTATIC, "Tab Size",  25, 85, 56, 21, _
      %WS_Child Or %WS_Visible Or %WS_Group Or %SS_Left
   Control Add TextBox, hTabDlg(2), %IDC_TEXT_TabSize, "3", 135, 85, 41, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %ES_Right Or %ES_AutoHScroll Or %ES_Number

   Control Add Label, hTabDlg(2), %IDSTATIC, "REM Column",  25, 115, 78, 21, _
      %WS_Child Or %WS_Visible Or %WS_Group Or %SS_Left
   Control Add TextBox, hTabDlg(2), %IDC_TEXT_REMColumn, "50", 135, 115, 41, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %ES_Right Or %ES_AutoHScroll Or %ES_Number

   Control Add CheckBox, hTabDlg(2), %IDC_CHK_FormatMacro, "Format Macro", 25, 155, 151, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_AutoCheckbox Or %BS_Left Or %BS_VCenter Or %BS_RightButton

   Control Add CheckBox, hTabDlg(2), %IDC_CHK_FormatEquates, "Format", 250, 25, 151, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_AutoCheckbox Or %BS_Left Or %BS_VCenter Or %BS_RightButton

   Control Add Label, hTabDlg(2), %IDSTATIC, "Column",  250,  55, 61, 21, _
      %WS_Child Or %WS_Visible Or %WS_Group Or %SS_Left
   Control Add TextBox, hTabDlg(2), %IDC_TEXT_EquateColumn, "35", 360,  55, 41, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %ES_Right Or %ES_AutoHScroll Or %ES_Number

   Control Add CheckBox, hTabDlg(2), %IDC_CHK_UpCaseEquates, "UpCase", 250, 85, 151, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_AutoCheckbox Or %BS_Left Or %BS_VCenter Or %BS_RightButton

   Control Add Frame, hTabDlg(2), %IDSTATIC, "Equates", 235,  5, 181, 121, _
      %WS_Child Or %WS_Visible Or %WS_ClipSiblings Or %WS_Group Or _
      %BS_Groupbox

   Control Add CheckBox, hTabDlg(2), %IDC_CHK_SplitVariables, "Split Variables", _
      250, 150, 151, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_AutoCheckbox Or %BS_Left Or %BS_VCenter Or %BS_RightButton

   Control Add Label, hTabDlg(2), %IDSTATIC, "AS column", 250, 185, 81, 21, _
      %WS_Child Or %WS_Visible Or %WS_Group Or %SS_Left
   Control Add TextBox, hTabDlg(2), %IDC_TEXT_AsColumn, "40", 360, 185, 41, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or %ES_Right Or %ES_AutoHScroll Or %ES_Number

   Control Add Frame, hTabDlg(2), %IDSTATIC, "", 235, 135, 181,  86, _
      %WS_Child Or %WS_Visible Or %WS_ClipSiblings Or %WS_Group Or _
      %BS_Groupbox

   Control Add Button, hTabDlg(2), %IDC_BTN_SaveOption, "Save Option",  20, 250, 156, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_PushButton Or %BS_Center Or %BS_VCenter

   Control Add Button, hTabDlg(2), %IDC_BTN_DefaultOption, "Default Option", 235, 250, 156, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_PushButton Or %BS_Center Or %BS_VCenter

   ' Page 3
   ' %WS_GROUP...
   Control Add Option,   hTabDlg(3), %IDC_OPT_PBWin, "PB Win", 8, 16, 95, 24, %WS_Child Or _
      %WS_Visible Or %WS_Group Or %WS_TabStop Or %BS_Text Or %BS_AutoRadioButton Or _
      %BS_Left Or %BS_VCenter, %WS_Ex_Left Or %WS_Ex_LtrReading
   Control Add Option,   hTabDlg(3), %IDC_OPT_PBCC, "PB CC", 8, 40, 95, 24
   Control Add Option,   hTabDlg(3), %IDC_OPT_Generic, "Generic", 8, 64, 95, 24
   Control Add Label,    hTabDlg(3), %IDSTATIC, "Version", 144, 16, 56, 24
   ' %WS_GROUP...
   Control Add ComboBox, hTabDlg(3), %IDC_CB_Version, , 144, 40, 75, 24, %WS_Child Or %WS_Visible _
      Or %WS_Group Or %WS_TabStop Or %CBS_DropDownList, %WS_Ex_Left Or %WS_Ex_LtrReading Or _
      %WS_Ex_RightScrollbar

   Control Add Frame,    hTabDlg(3), %IDSTATIC, "Keywords", 0, 104, 151, 144
   ' %WS_GROUP...
   Control Add Option,   hTabDlg(3), %IDC_OPT_NoChange, "No change", 16, 128, 112, 24, %WS_Child Or _
      %WS_Visible Or %WS_Group Or %WS_TabStop Or %BS_Text Or %BS_AutoRadioButton Or _
      %BS_Left Or %BS_VCenter, %WS_Ex_Left Or %WS_Ex_LtrReading
   Control Add Option,   hTabDlg(3), %IDC_OPT_Mixed, "Mixed Case", 16, 155, 112, 24
   Control Add Option,   hTabDlg(3), %IDC_OPT_Upper, "UPPER CASE", 16, 184, 112, 24
   Control Add Option,   hTabDlg(3), %IDC_OPT_Lower, "lower case", 16, 213, 112, 24

   Control Add Button, hTabDlg(3), %IDC_BTN_SaveOption, "Save Option",  20, 250, 156, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_PushButton Or %BS_Center Or %BS_VCenter

   Control Add Button, hTabDlg(3), %IDC_BTN_DefaultOption, "Default Option", 235, 250, 156, 21, _
      %WS_Child Or %WS_Visible Or %WS_TabStop Or _
      %BS_PushButton Or %BS_Center Or %BS_VCenter

   ComboBox Add hTabDlg(3), %IDC_CB_Version, " "
   ComboBox Add hTabDlg(3), %IDC_CB_Version, "WN v10"
   ComboBox Add hTabDlg(3), %IDC_CB_Version, "CC v6"

   PutOvars

End Function

'------------------------------------------------------------------------------

CallBack Function TabProc()

   Select Case As Long Cb.Msg
      Case %WM_InitDialog
         ' Initialization handler

      Case %WM_NCActivate
         Static hWndSaveFocus As Dword
         If IsFalse Cb.WParam Then
            ' Save control focus
            hWndSaveFocus = GetFocus()
         ElseIf hWndSaveFocus Then
            ' Restore control focus
            SetFocus(hWndSaveFocus)
            hWndSaveFocus = 0
         End If

      Case %WM_Command
         ' Process control notifications
         Select Case As Long Cb.Ctl

' tab 1
            Case %IDC_BTN_InputFile
               If Cb.CtlMsg = %BN_Clicked Then
                  Btn_InputFile_Clicked Cb.Hndl
                  msghandled
               End If

            Case %IDC_TEXT_InputFile
               If Cb.CtlMsg = %EN_Change Then
                  Text_InputFile_Change Cb.Hndl
                  msghandled
               End If

            Case %IDC_BTN_OutputFile
               If Cb.CtlMsg = %BN_Clicked Then
                  Btn_OutputFile_Clicked Cb.Hndl
                  msghandled
               End If

            Case %IDC_TEXT_OutputFile
               If Cb.CtlMsg = %EN_Change Then
                  Text_OutputFile_Change Cb.Hndl
                  msghandled
               End If

' tab 2
            Case %IDC_CHK_CreateBak
               If Cb.CtlMsg = %BN_Clicked Then
                  msghandled
               End If

            Case %IDC_CHK_CreateTimeStamp
               If Cb.CtlMsg = %BN_Clicked Then
                  ' do nothing yet
                  msghandled
               End If

            Case %IDC_CHK_SplitVariables
               If Cb.CtlMsg = %BN_Clicked Then
                  msghandled
               End If

            Case %IDC_TEXT_AsColumn
               If Cb.CtlMsg = %EN_Change Then
                  ' do nothing yet
                  msghandled
               End If

            Case %IDC_TEXT_TabSize
               If Cb.CtlMsg = %EN_Change Then
                  ' do nothing yet
                  msghandled
               End If

            Case %IDC_TEXT_REMColumn
               If Cb.CtlMsg = %EN_Change Then
                  ' do nothing yet
                  msghandled
               End If

            Case %IDC_CHK_FormatMacro
               If Cb.CtlMsg = %BN_Clicked Then
                  ' do nothing yet
                  msghandled
               End If

            Case %IDC_CHK_FormatEquates
               If Cb.CtlMsg = %BN_Clicked Then
                  msghandled
               End If

            Case %IDC_CHK_UpCaseEquates
               If Cb.CtlMsg = %BN_Clicked Then
                  ' do nothing yet
                  msghandled
               End If

            Case %IDC_TEXT_EquateColumn
               If Cb.CtlMsg = %EN_Change Then
                  ' do nothing yet
                  msghandled
               End If

' common tab 2 & 3
            Case %IDC_BTN_SaveOption
               If Cb.CtlMsg = %BN_Clicked Then
                  Btn_SaveOption_Clicked
                  msghandled
               End If

            Case %IDC_BTN_DefaultOption
               If Cb.CtlMsg = %BN_Clicked Then
                  Btn_DefaultOption_Clicked
                  msghandled
               End If
         End Select
   End Select

End Function

Function Btn_InputFile_Clicked(ByVal hWndParent As Dword) As Long

   Display Openfile hWndParent, 0, 0, "Format Powerbasic Code", "", _
      Chr$( "Basic Source [BAS, INC]", 0, "*.BAS;*.INC", 0), _
      "", "", %OFN_FileMustExist To fo.fspecin

   If Len(fo.fspecin) <> 0 Then
      Control Set Text hTabDlg(1), %IDC_TEXT_INPUTFILE, fo.fspecin
      Control Enable mainhDlg, %IDC_BTN_FORMAT
      If Len(fo.fspecin) Then
         Control Enable mainhDlg, %IDC_BTN_FORMAT
      Else
         Control Disable mainhDlg, %IDC_BTN_FORMAT
      End If
   End If
End Function

Function Text_InputFile_Change(ByVal hWndParent As Dword ) As Long

   Control Get Text hTabDlg(1), %IDC_TEXT_InputFile To fo.fspecin
   If Len(fo.fspecin) Then
      Control Enable mainhDlg, %IDC_BTN_FORMAT
   Else
      Control Disable mainhDlg, %IDC_BTN_FORMAT
   End If

End Function

Function Btn_OutputFile_Clicked(ByVal hWndParent As Dword ) As Long

   Display Openfile hWndParent, 0, 0, "OUTPUT Powerbasic Code", "", _
      Chr$( "Basic Source [BAS, INC]", 0, "*.BAS;*.INC", 0), _
      "", "", %OFN_CreatePrompt Or %OFN_NoTestFileCreate To fo.fspecout

   If Len(fo.fspecout) Then
      Control Set Text hTabDlg(1), %IDC_TEXT_OUTPUTFILE, fo.fspecout
      If Len(fo.fspecin) Then
         Control Enable mainhDlg, %IDC_BTN_FORMAT
      Else
         Control Disable mainhDlg, %IDC_BTN_FORMAT
      End If
   End If

End Function

Function Text_OutputFile_Change(ByVal hWndParent  As Dword) As Long

   Control Get Text hTabDlg(1), %IDC_TEXT_OutputFile To fo.fspecout
   If Len(fo.fspecout) And Len(fo.fspecin) Then
      Control Enable mainhDlg, %IDC_BTN_FORMAT
   Else
      Control Disable mainhDlg, %IDC_BTN_FORMAT
   End If

End Function

Function Btn_SaveOption_Clicked As Long
   Local filenum As Dword

   GetOVars()

   filenum = FreeFile
   Open "Code Formatter.cfg" For Binary As filenum
   Put filenum,,fo
   Close filenum
End Function

Function Btn_DefaultOption_Clicked As Long

   SetDefaultOptions

   PutOVars ' only if form is up

End Function

Sub SetDefaultOptions
   Local fx As FMTOPTIONS

   fo = fx ' clear everything
   fo.version         = %CFGVersion
   fo.fspecin         = ""
   fo.fspecout        = ""
   fo.backup          = 1
   fo.backupTimeStamp = 0
   fo.tabsize         = 3
   fo.remcol          = 50
   fo.formatMacro     = 0
   fo.lineupequates   = 1
   fo.equatescolumn   = 35
   fo.capequates      = 1
   fo.splitvariables  = 1  ' added v2
   fo.ascolumn        = 40 ' added v2
   fo.PBCompiler      = "GEN"
   fo.PBVersion       = " " ' blank
   fo.keywordCase     = 1 ' no change
End Sub

Sub GetOVars
   Local rtc As Long
   Local wrk As String

   Control Get Check hTabDlg(2), %IDC_CHK_CreateBak To rtc
   fo.backup = rtc
   Control Get Check hTabDlg(2), %IDC_CHK_CreateTimeStamp To rtc
   fo.backupTimeStamp = rtc

   Control Get Text hTabDlg(2), %IDC_Text_TabSize To wrk
   fo.tabsize = Val(wrk)
   Control Get Text hTabDlg(2), %IDC_Text_RemColumn To wrk
   fo.remcol = Val(wrk)
   Control Get Check hTabDlg(2), %IDC_CHK_FormatMacro To rtc
   fo.formatMacro = rtc

   Control Get Check hTabDlg(2), %IDC_CHK_FormatEquates To rtc
   fo.lineupequates = rtc
   Control Get Text hTabDlg(2), %IDC_Text_EquateColumn To wrk
   fo.equatescolumn = Val(wrk)
   Control Get Check hTabDlg(2), %IDC_CHK_UpCaseEquates To rtc
   fo.capequates = rtc

   Control Get Check hTabDlg(2), %IDC_CHK_SplitVariables To rtc
   fo.splitvariables = rtc
   Control Get Text hTabDlg(2), %IDC_Text_AsColumn To wrk
   fo.ascolumn = Val(wrk)

   wrk = "GEN"
   Control Get Check hTabDlg(3), %IDC_OPT_PBWin To rtc
   If rtc = 1 Then wrk = "WIN"
   Control Get Check hTabDlg(3), %IDC_OPT_PBCC To rtc
   If rtc = 1 Then wrk = "CC"
   fo.PBcompiler = wrk
   ComboBox Get Select hTabDlg(3), %IDC_CB_Version To rtc
   ComboBox Get Text   hTabDlg(3), %IDC_CB_Version, rtc To wrk
   fo.PBversion = wrk

   wrk = "1" ' no change
   Control Get Check hTabDlg(3), %IDC_OPT_Mixed To rtc
   If rtc = 1 Then wrk = "2"
   Control Get Check hTabDlg(3), %IDC_OPT_Upper To rtc
   If rtc = 1 Then wrk = "3"
   Control Get Check hTabDlg(3), %IDC_OPT_Lower To rtc
   If rtc = 1 Then wrk = "4"
   fo.keywordCase = Val(wrk)

End Sub

Sub PutOVars
   Local rtc As Long

   Control Set Check hTabDlg(2), %IDC_CHK_CreateBak, fo.backup
   Control Set Check hTabDlg(2), %IDC_CHK_CreateTimeStamp, fo.backupTimeStamp

   Control Set Text hTabDlg(2), %IDC_TEXT_TabSize, Format$(fo.tabsize)
   Control Set Text hTabDlg(2), %IDC_TEXT_RemColumn, Format$(fo.remcol)
   Control Set Check hTabDlg(2), %IDC_CHK_FormatMacro, fo.formatMacro

   Control Set Check hTabDlg(2), %IDC_CHK_FormatEquates, fo.lineupequates
   Control Set Text hTabDlg(2), %IDC_TEXT_EquateColumn, Format$(fo.equatescolumn)
   Control Set Check hTabDlg(2), %IDC_CHK_UpCaseEquates, fo.capequates

   Control Set Check hTabDlg(2), %IDC_CHK_SplitVariables, fo.splitvariables
   Control Set Text hTabDlg(2), %IDC_TEXT_AsColumn, Format$(fo.ascolumn)

   If fo.PBcompiler = "WIN" Then
      Control Set Check hTabDlg(3), %IDC_OPT_Generic, 0
      Control Set Check hTabDlg(3), %IDC_OPT_PBWin, 1
      Control Set Check hTabDlg(3), %IDC_OPT_PBCC, 0
   ElseIf fo.PBcompiler = "CC" Then
      Control Set Check hTabDlg(3), %IDC_OPT_Generic, 0
      Control Set Check hTabDlg(3), %IDC_OPT_PBWin, 0
      Control Set Check hTabDlg(3), %IDC_OPT_PBCC, 1
   Else
      Control Set Check hTabDlg(3), %IDC_OPT_Generic, 1
      Control Set Check hTabDlg(3), %IDC_OPT_PBWin, 0
      Control Set Check hTabDlg(3), %IDC_OPT_PBCC, 0
   End If
   ComboBox Find Exact hTabDlg(3), %IDC_CB_Version, 1, fo.PBVersion To rtc
   ComboBox Select     hTabDlg(3), %IDC_CB_Version, rtc

   If fo.keywordCase = 2 Then
      Control Set Check hTabDlg(3), %IDC_OPT_NoChange, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Mixed, 1
      Control Set Check hTabDlg(3), %IDC_OPT_Upper, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Lower, 0
   ElseIf fo.keywordCase = 3 Then
      Control Set Check hTabDlg(3), %IDC_OPT_NoChange, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Mixed, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Upper, 1
      Control Set Check hTabDlg(3), %IDC_OPT_Lower, 0
   ElseIf fo.keywordCase = 4 Then
      Control Set Check hTabDlg(3), %IDC_OPT_NoChange, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Mixed, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Upper, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Lower, 1
   Else
      Control Set Check hTabDlg(3), %IDC_OPT_NoChange, 1
      Control Set Check hTabDlg(3), %IDC_OPT_Mixed, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Upper, 0
      Control Set Check hTabDlg(3), %IDC_OPT_Lower, 0
   End If
End Sub

Sub Show_ProgressBar
   If NoGui = 0 Then
      Control Set Text mainhDlg, %IDC_StatusBar, ""
      Control Normalize mainhDlg, %IDC_PROGRESS
      Progressbar Set Range mainhDlg, %IDC_PROGRESS, 1, 100
      Progressbar Set Step  mainhDlg, %IDC_PROGRESS, 1
      Progressbar Set Pos mainhDlg, %IDC_Progress, 1
   Else
      hProgressBar = CaptionProgressWindow(0, "Format Source Code")
   End If
End Sub

Sub Update_ProgressBar(pbloc As Long)
   If NoGui = 0 Then
      Progressbar Set Pos mainhDlg, %IDC_Progress, pbloc
   Else
      SendMessage hProgressBar, %PBM_SETPOS, pbloc, 0
   End If
End Sub

Sub Hide_ProgressBar(maxtokens As Long)
   If NoGui = 0 Then
      Progressbar Set Pos mainhDlg, %IDC_Progress, 1
      Control Hide mainhDlg, %IDC_Progress
      Control Set Text mainhDlg, %IDC_StatusBar, "max tokens in a line " & Str$(maxtokens)
   Else
      Sleep 5000
      DestroyWindow hProgressBar
   End If
End Sub

Function CaptionProgressWindow(ByVal hparent As Dword, ByVal PBCAPTION As String) As Dword
    '--------------------------------------------------------------------------
    'Create a centered progress control with caption and return handle
    '--------------------------------------------------------------------------
    Local rc As RECT
    Local hwin As Dword                                    'progress control handle
    Local ht As Long                                       'window height & width
    Local wd As Long                                       'window height & width

    'fetch desktop size
    SystemParametersInfo %SPI_GETWORKAREA, 0, rc, 0
    ht = GetSystemMetrics(%SM_CYCAPTION)                   'height of window caption
    wd = rc.nright \ 2                                     '1/2 of screen width
    If hparent = 0 Then
        hparent = GetDesktopWindow
    End If
    hwin = CreateWindowEx(%WS_Ex_ToolWindow Or %WS_Ex_DlgModalFrame, "msctls_progress32", _
                           ByVal StrPtr(PBCAPTION), _
                           %WS_Visible Or %WS_Caption Or %WS_Popup Or %PBS_Smooth, _
                           (rc.nright \ 2) - (wd \ 2), _   'horiz pos start
                           (rc.nbottom \ 2) - ht, _        'vert  pos start
                           wd, _                           'width, 1/2 screen
                           ht * 2, _                       'height, 2 * caption
                           hparent, 0, GetModuleHandle(ByVal %NULL), ByVal %NULL)
    Function = hwin                                        'return progress handle
End Function


' ************************************************
' ================================================
' functions that do not interact with GUI
'  are below here
' ** exception DoFormat updates Progress Bar
' ================================================
' ************************************************
Sub NON_GUI
   '
End Sub


#Link "DoFormat.sll"
' #Include "DoFormat.bas"
